#include "stdafx.h"
#include "SimpleTabControl.h"
#include "TabControl.h"


// CTabControl

IMPLEMENT_DYNAMIC(CTabControl, CTabCtrl)
CTabControl::CTabControl()
{
	m_nIndex = -1;
}

BEGIN_MESSAGE_MAP(CTabControl, CTabCtrl)
	ON_NOTIFY_REFLECT(NM_CLICK, OnNMClick)
	ON_WM_MOVE()
END_MESSAGE_MAP()


// CTabControl message handlers
void CTabControl::OnNMClick(NMHDR *pNMHDR, LRESULT *pResult)
{
	// TODO: Add your control notification handler code here
	CDialog *p;

	m_nIndex = GetCurSel();

	int iPaneCount=0;
	while(iPaneCount< m_panes.GetCount())
	{
		p = m_panes.GetAt(iPaneCount);
		p->ShowWindow(SW_HIDE);
		iPaneCount++;
	}
	p = m_panes.GetAt(m_nIndex);
	CRect rect;
	GetWindowRect(rect);
	p->SetWindowPos(&CWnd::wndBottom,rect.left+3,rect.top+25,rect.Width()-7,rect.Height()-30,SWP_SHOWWINDOW);
	p->ShowWindow(SW_SHOW); 
	*pResult = 0;
}

void CTabControl::OnMove(int x, int y)
{
	CTabCtrl::OnMove(x, y);
	CDialog *p;
	if(m_nIndex > -1)
	{
		p = m_panes.GetAt(m_nIndex);
		CRect rect;
		GetWindowRect(rect);
		p->SetWindowPos(&CWnd::wndBottom,rect.left+3,rect.top+25,rect.Width()-7,rect.Height()-30,SWP_SHOWWINDOW);
		p->ShowWindow(SW_SHOW); 
	}
}

void CTabControl::AddTabPane(CString strCaption,CDialog * pDlg)
{
	m_captions.Add(strCaption); 
	m_panes.Add(pDlg); 

	TCITEM tci;
	tci.mask = TCIF_TEXT;
	tci.pszText = (LPSTR)(LPCTSTR) strCaption;
	tci.cchTextMax = strCaption.GetLength();
	InsertItem((int)(m_captions.GetCount()-1),&tci);
}

void CTabControl::SetDefaultPane(int iPaneIndex)
{
	CDialog *p;

	m_nIndex = iPaneIndex;
	if(iPaneIndex < m_panes.GetCount())
	{
		SetCurSel(iPaneIndex);
		p = m_panes.GetAt(iPaneIndex);
		CRect rect;
		GetWindowRect(rect);
		p->SetWindowPos(&CWnd::wndBottom,rect.left+3,rect.top+25,rect.Width()-7,rect.Height()-30,SWP_SHOWWINDOW);
		p->ShowWindow(SW_SHOW); 
	}
}
